#include "endian.h"
#include <stdio.h>
#include <sys/stat.h>

int main(int argc, char *argv[] )
{
	struct stat st;
	FILE *in;
	FILE *out;
	int i,i2;
	unsigned long int asize, filesize;

	char start[8] =  { 0x43, 0x4f, 0x42, 0x52, 0x41, 0x4d, 0x42, 0x31 };
	char fill[1] = { 0x00 };
	unsigned long int offset[1] = { 0x00000000 };
	unsigned long int endoff[1] = { 0x00000000 };

	// number of bytes read this iteration
	int len = 0;

	// number of bytes read this file
	int count = 0;

	// initial size of that particular iso
	int isize = 0;

	int percent =0;
	int pcheck = 0;
	int doPadding = 0;

	// temporary buffer for copying
	char buffer[1024];




	printf("\nMulti disc GCM maker 0.1\n");
	printf("by badsheepy, mod by POi\n");

	if (argc<=1) {
		printf("\nRun multi.exe <.gcm/.iso> <.gcm/.iso> ...\n");
		printf("eg. multi.exe game1.iso game2.gcm game3.gcm ... \n");
		return(1);
	}



	out = fopen("outfile.iso","wb");

	// write header (8 byte identifier)
	fwrite(start,1,8,out);

	// write header (pad till beginning of offsets)
	for (i=1;i<=(0x40-0x08);i++)
	{
		fwrite(fill,1,1,out);
	}


	// 32k aligned so offset is always 32768
	// ( unless you have 8000 isos on this one disk :P )
	offset[0]=32768;



	//ok now get sizes of each file and write offsets
	for(i=1;i<argc;i++) {
		if(stat(argv[i],&st) !=(-1))
		{
			endoff[0]=offset[0];
			SWAP_LONG(endoff[0]);
			fwrite(endoff,sizeof(offset[0]),1,out);
			//    printf("%s: file size in bytes: %d\n", argv[i], st.st_size);
			asize=st.st_size%32768;
			asize=32768-asize;
			if (asize==32768) asize=0;
			//    printf("padding is %d\n", asize);

			offset[0]+=(st.st_size+asize);
		}
		else
		{
			printf("Input file not found\n");
			return(1);
		}

	}

	if (offset[0]>1459978240)
	{
		printf("WARNING: Compilation is too big to fit on a mini dvd-r\n");
		printf("         There are %.0f KB too many.\n",(float)(offset[0]-1459978240)/1024);
		printf("         Iso will be created but will probably be unusable.\n");
		doPadding = 0;
	}
	else
	{
		doPadding = 1;
	}
	

	// set i2 to the first byte after the list of gcm offsets
	i2=0x40;
	i2+=(argc-1)*4; 

	// fill from i2 to 32kb with zeros for alignment
	for(i=i2+1;i<=32768;i++)
	{
		fwrite(fill,1,1,out);
	}


	for(i=1;i<argc;i++) {
		in = fopen(argv[i],"rb");
		stat(argv[i],&st);

		isize=st.st_size;
		asize=st.st_size%32768;
		asize=32768-asize;
		if(asize==32768) asize=0;

		count=0;
		printf("\nAdding %s at %uk and %uk padding   0 percent done", argv[i], isize/1024, asize/1024);

		while((len = fread(buffer,1,sizeof(buffer),in)) > 0)
		{
			fwrite(buffer,1,len,out);
			count+=len;
			pcheck = ((float)count/(float)isize)*100;
			if (pcheck!=percent)
			{ percent=pcheck; printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%3u percent done",percent); }
		}

		// pad the rest to 32k
		for(i2=1;i2<=asize;i2++) fwrite(fill,1,1,out);

		fclose(in);
	}

	/*
	// make output iso a multiple of 2048 for the block size
	asize=offset[0]%2048;
	asize=2048-asize;
	if (asize!=2048)
	{
	for (i=1;i<=asize;i++)
	{
	fwrite(fill,1,1,out);
	}
	}
	*/
	// Pad to 1.36gb here
	
	if(doPadding == 1)
	{
		printf("\nPlease wait padding iso...");
		for (i=offset[0]+1;i<=1459978240;i++)
		{
			fwrite(fill,1,1,out);
		}
	}
	else
	{
		printf("\nNo padding needed...");
	}

	
	printf("done.\n");

	fclose(out);

	printf("Iso created.\n");

	return(0);
}
